Magento 2.3. Need to grant access to customer for using some APIs

I have gone through from regular authentication process as a customer and successfully used some Magento Rest APIs. Some APIs are working fine and some apis are returning responses like that;

Example: I need to get details of a specific product:

Endpoint: /V1/products/{sku}  Response: { "message": "Consumer is not authorized to access %resources", "parameters": {     "resources": "Magento_Catalog::products" }} 

As admin, I can access these resources. But I need to access these resources as a customer.

I am using community edition of Magento 2.3.

I need to ask how can I grant access to customer and guest user of these resources.

Magento 2.3. changing form validation options loses validation messages translations

I am running Magento 2.3. In the customer create account form I changed the way validation form errors are shown in this way:

var dataForm = $  ('#form-validate');  dataForm.mage('validation', {     errorPlacement: function(error, element) {         ... custom functionality ...     } } 

Doing this all the validation messages lose their translations and are shown in English. If I comment out this piece of code teh messages are shown in the current store language.

Anyone had this behaviour before?

Can’t upgrade database from 2.2.7 to 2.3. Cannot process definition to array for type enum

Magento 2.2.7 to 2.3

Started at 2.2.3 and upgraded incrementally via command line.

Php 7.2 is enabled. Did not enable until ready to upgrade to 2.3 b/c 7.1 support ended on M2.3

SQL Version: 10.1.36-MariaDB-cll-lve

Quick history.

Tried to use Web Setup to go from 2.2.3 to 2.3. Failed with no failure screen. Tried again. Got a failure (I imagine after going thru this is was php 7.2 related and honestly, Web Setup shouldn’t have even allowed me the option to do it this way. CLI should be the only way) and provided rollback option, but didn’t know at this point what it would roll back to b/c it gave no indication on the prior failure what happened so I didn’t do the rollback. I think this may have be the source of my current database issues b/c it seems stuck in between states, as in between structure of 2.2.x and 2.3.

The Issue:

I upgraded via CLI to 2.2.7 and everything was working well except, as I noticed during the upgrade, I couldn’t make a DB backup due to “Area Code already existing”. I had an older backup, so I proceeded anyway. In too deep at this point.

I then tried to upgrade to 2.3 as per instructions at Magento Dev Docs. I made it to the end to rebuilt database via command

php bin/magento setup:upgrade

It failed with the following error:

Cannot process definition to array for type enum

It made it thru a few of the file system cleanups, then threw that error. So, I turned off the maintenance mode so I could see what was going on. Sure enough, the database didn’t upgrade. I thought it was due to the modules in the report at the end of this message being outdated, so I turned OFF ALL modules via CLI. I then tried to upgrade. Same “Cannot process definition to array for type enum” message.

At this point I am stumped and I’d really not like to roll back to the older db backup and lose some work if possible.

Any one have an idea on how I can get this database to complete the upgrade so I can enjoy the relative bliss that must be Magento 2.3? :smileylol:

Thanks in advance!

Kory

—–begin error report from post db upgrade——–

{“0″:”Please upgrade your database: Run \”bin/magento setup:upgrade\” from the Magento root directory.\nThe following modules are outdated:\nMSP_ReCaptcha schema: current version – none, required version – 1.5.0\nMSP_ReCaptcha data: current version – none, required version – 1.5.0\nMSP_TwoFactorAuth schema: current version – none, required version – 2.2.0\nMSP_TwoFactorAuth data: current version – none, required version – 2.2.0\nAmazon_Core schema: current version – 2.1.2, required version – 3.0.0\nAmazon_Core data: current version – 2.1.2, required version – 3.0.0\nMagento_Inventory schema: current version – none, required version – 1.0.0\nMagento_Inventory data: current version – none, required version – 1.0.0\nMagento_InventoryAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryAdminUi data: current version – none, required version – 1.0.0\nMagento_InventoryApi schema: current version – none, required version – 1.0.0\nMagento_InventoryApi data: current version – none, required version – 1.0.0\nMagento_InventoryBundleProduct schema: current version – none, required version – 1.0.0\nMagento_InventoryBundleProduct data: current version – none, required version – 1.0.0\nMagento_InventoryBundleProductAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryBundleProductAdminUi data: current version – none, required version – 1.0.0\nMagento_InventoryCatalog schema: current version – none, required version – 1.0.0\nMagento_InventoryCatalog data: current version – none, required version – 1.0.0\nMagento_InventorySales schema: current version – none, required version – 1.0.0\nMagento_InventorySales data: current version – none, required version – 1.0.0\nMagento_InventoryCatalogAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryCatalogAdminUi data: current version – none, required version – 1.0.0\nMagento_InventoryCatalogApi schema: current version – none, required version – 1.0.0\nMagento_InventoryCatalogApi data: current version – none, required version – 1.0.0\nMagento_InventoryCatalogSearch schema: current version – none, required version – 1.0.0\nMagento_InventoryCatalogSearch data: current version – none, required version – 1.0.0\nMagento_InventoryConfigurableProduct schema: current version – none, required version – 1.0.0\nMagento_InventoryConfigurableProduct data: current version – none, required version – 1.0.0\nMagento_InventoryConfigurableProductAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryConfigurableProductAdminUi data: current version – none, required version – 1.0.0\nMagento_InventoryConfigurableProductIndexer schema: current version – none, required version – 1.0.0\nMagento_InventoryConfigurableProductIndexer data: current version – none, required version – 1.0.0\nMagento_InventoryConfiguration schema: current version – none, required version – 1.0.0\nMagento_InventoryConfiguration data: current version – none, required version – 1.0.0\nMagento_InventoryConfigurationApi schema: current version – none, required version – 1.0.0\nMagento_InventoryConfigurationApi data: current version – none, required version – 1.0.0\nMagento_InventoryGroupedProduct schema: current version – none, required version – 1.0.0\nMagento_InventoryGroupedProduct data: current version – none, required version – 1.0.0\nMagento_InventoryGroupedProductAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryGroupedProductAdminUi data: current version – none, required version – 1.0.0\nMagento_InventoryGroupedProductIndexer schema: current version – none, required version – 1.0.0\nMagento_InventoryGroupedProductIndexer data: current version – none, required version – 1.0.0\nMagento_InventoryImportExport schema: current version – none, required version – 1.0.0\nMagento_InventoryImportExport data: current version – none, required version – 1.0.0\nMagento_InventoryIndexer schema: current version – none, required version – 1.0.0\nMagento_InventoryIndexer data: current version – none, required version – 1.0.0\nMagento_InventoryLowQuantityNotification schema: current version – none, required version – 1.0.0\nMagento_InventoryLowQuantityNotification data: current version – none, required version – 1.0.0\nMagento_InventoryLowQuantityNotificationAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryLowQuantityNotificationAdminUi data: current version – none, required version – 1.0.0\nMagento_InventoryLowQuantityNotificationApi schema: current version – none, required version – 1.0.0\nMagento_InventoryLowQuantityNotificationApi data: current version – none, required version – 1.0.0\nMagento_InventoryMultiDimensionalIndexerApi schema: current version – none, required version – 1.0.0\nMagento_InventoryMultiDimensionalIndexerApi data: current version – none, required version – 1.0.0\nMagento_InventoryProductAlert schema: current version – none, required version – 1.0.0\nMagento_InventoryProductAlert data: current version – none, required version – 1.0.0\nMagento_InventoryReservations schema: current version – none, required version – 1.0.0\nMagento_InventoryReservations data: current version – none, required version – 1.0.0\nMagento_InventoryReservationsApi schema: current version – none, required version – 1.0.0\nMagento_InventoryReservationsApi data: current version – none, required version – 1.0.0\nMagento_InventoryCache schema: current version – none, required version – 1.0.0\nMagento_InventoryCache data: current version – none, required version – 1.0.0\nMagento_InventorySalesAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventorySalesAdminUi data: current version – none, required version – 1.0.0\nMagento_InventorySalesApi schema: current version – none, required version – 1.0.0\nMagento_InventorySalesApi data: current version – none, required version – 1.0.0\nMagento_InventoryShipping schema: current version – none, required version – 1.0.0\nMagento_InventoryShipping data: current version – none, required version – 1.0.0\nMagento_InventorySourceDeductionApi schema: current version – none, required version – 1.0.0\nMagento_InventorySourceDeductionApi data: current version – none, required version – 1.0.0\nMagento_InventorySourceSelection schema: current version – none, required version – 1.0.0\nMagento_InventorySourceSelection data: current version – none, required version – 1.0.0\nMagento_InventorySourceSelectionApi schema: current version – none, required version – 1.0.0\nMagento_InventorySourceSelectionApi data: current version – none, required version – 1.0.0\nKlarna_Core schema: current version – 4.5.2, required version – 5.0.0\nKlarna_Core data: current version – 4.5.2, required version – 5.0.0\nAmazon_Login schema: current version – 2.1.1, required version – 3.0.0\nAmazon_Login data: current version – 2.1.1, required version – 3.0.0\nAmazon_Payment schema: current version – 2.1.1, required version – 3.0.0\nAmazon_Payment data: current version – 2.1.1, required version – 3.0.0\nKlarna_Ordermanagement schema: current version – 4.4.1, required version – 5.0.2\nKlarna_Ordermanagement data: current version – 4.4.1, required version – 5.0.2\nMagento_InventoryShippingAdminUi schema: current version – none, required version – 1.0.0\nMagento_InventoryShippingAdminUi data: current version – none, required version – 1.0.0\nKlarna_Kp schema: current version – 5.5.1, required version – 6.0.0\nKlarna_Kp data: current version – 5.5.1, required version – 6.0.0\nDotdigitalgroup_Email schema: current version – 2.6.1, required version – 3.0.1\nDotdigitalgroup_Email data: current version – 2.6.1, required version – 3.0.1\nTemando_Shipping schema: current version – 1.2.1, required version – 1.4.0\nTemando_Shipping data: current version – 1.2.1, required version – 1.4.0″,”1″:”#0 /home/stebbins/public_html/vendor/magento/framework/Interception/Interceptor.php(121): Magento\Framework\Module\Plugin\DbStatusValidator->beforeDispatch(Object(Magento\Framework\App\FrontController\Interceptor), Object(Magento\Framework\App\Request\Http))\n#1 /home/stebbins/public_html/vendor/magento/module-page-cache/Model/App/FrontController/BuiltinPlugin.php(73): Magento\Framework\App\FrontController\Interceptor->Magento\Framework\Interception\{closure}(Object(Magento\Framework\App\Request\Http))\n#2 /home/stebbins/public_html/vendor/magento/framework/Interception/Interceptor.php(135): Magento\PageCache\Model\App\FrontController\BuiltinPlugin->aroundDispatch(Object(Magento\Framework\App\FrontController\Interceptor), Object(Closure), Object(Magento\Framework\App\Request\Http))\n#3 /home/stebbins/public_html/vendor/magento/framework/Interception/Interceptor.php(153): Magento\Framework\App\FrontController\Interceptor->Magento\Framework\Interception\{closure}(Object(Magento\Framework\App\Request\Http))\n#4 /home/stebbins/public_html/generated/code/Magento/Framework/App/FrontController/Interceptor.php(26): Magento\Framework\App\FrontController\Interceptor->___callPlugins(‘dispatch’, Array, Array)\n#5 /home/stebbins/public_html/vendor/magento/framework/App/Http.php(135): Magento\Framework\App\FrontController\Interceptor->dispatch(Object(Magento\Framework\App\Request\Http))\n#6 /home/stebbins/public_html/generated/code/Magento/Framework/App/Http/Interceptor.php(24): Magento\Framework\App\Http->launch()\n#7 /home/stebbins/public_html/vendor/magento/framework/App/Bootstrap.php(258): Magento\Framework\App\Http\Interceptor->launch()\n#8 /home/stebbins/public_html/index.php(39): Magento\Framework\App\Bootstrap->run(Object(Magento\Framework\App\Http\Interceptor))\n#9 {main}”,”url”:”/”,”script_name”:”/index.php”}